/*
Gentooza's Sudokus Resolver

Copyright(2018):  Joa Cuéllar <joa.cuellar (at) riseup.net>

Source code:
not yet

This app is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This app is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this app.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <iostream>
#include <vector>
#include <limits>
#include <string>

#include "defines.h"
#include "cell.h"
#include "methodsManager.h"


#ifndef _RESOLVER_
#define _RESOLVER_

class resolver
{
 public:
  resolver();
  ~resolver();

  void loadMethods(){myPluginManager->loadPlugins();};
  
  int setValues(std::vector< std::vector<int> > values);
  int analyze();
  std::vector< std::vector <std::string> > getCurrent();
  cell ** getCurrentCells(){return myCells;};
  
  void getCurrentStatus(std::vector <std::string> & status){status.clear(); status = vStatus;};
  void clearStatus(){vStatus.clear();};
  void newRound(){iRound++;vStatus.clear();std::string message = "Round "; message += std::to_string(iRound); vStatus.push_back(message);};
  int resolveOne();
    

 private:
  cell ** myCells;
  int iRound;
  std::vector <std::string> vStatus;
  int hasSollution;
  methodsManager* myPluginManager;
  
};

#endif
